// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: GeographyParametersResponse.proto

package ru.omnicomm.pegasus.messaging.data.responses;

public final class GeographyParametersResponseParser {
  private GeographyParametersResponseParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class GeographyParametersResponse extends
      com.google.protobuf.GeneratedMessage {
    // Use GeographyParametersResponse.newBuilder() to construct.
    private GeographyParametersResponse() {
      initFields();
    }
    private GeographyParametersResponse(boolean noInit) {}
    
    private static final GeographyParametersResponse defaultInstance;
    public static GeographyParametersResponse getDefaultInstance() {
      return defaultInstance;
    }
    
    public GeographyParametersResponse getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_fieldAccessorTable;
    }
    
    public enum State
        implements com.google.protobuf.ProtocolMessageEnum {
      NORMAL(0, 0),
      LAST(1, 1),
      DEFECTIVE(2, 2),
      ;
      
      
      public final int getNumber() { return value; }
      
      public static State valueOf(int value) {
        switch (value) {
          case 0: return NORMAL;
          case 1: return LAST;
          case 2: return DEFECTIVE;
          default: return null;
        }
      }
      
      public static com.google.protobuf.Internal.EnumLiteMap<State>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<State>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<State>() {
              public State findValueByNumber(int number) {
                return State.valueOf(number)
      ;        }
            };
      
      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.getDescriptor().getEnumTypes().get(0);
      }
      
      private static final State[] VALUES = {
        NORMAL, LAST, DEFECTIVE, 
      };
      public static State valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }
      private final int index;
      private final int value;
      private State(int index, int value) {
        this.index = index;
        this.value = value;
      }
      
      static {
        ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.getDescriptor();
      }
      
      // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.State)
    }
    
    public static final class Row extends
        com.google.protobuf.GeneratedMessage {
      // Use Row.newBuilder() to construct.
      private Row() {
        initFields();
      }
      private Row(boolean noInit) {}
      
      private static final Row defaultInstance;
      public static Row getDefaultInstance() {
        return defaultInstance;
      }
      
      public Row getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_fieldAccessorTable;
      }
      
      // required string vehicleId = 101;
      public static final int VEHICLEID_FIELD_NUMBER = 101;
      private boolean hasVehicleId;
      private java.lang.String vehicleId_ = "";
      public boolean hasVehicleId() { return hasVehicleId; }
      public java.lang.String getVehicleId() { return vehicleId_; }
      
      // required double pointDate = 102;
      public static final int POINTDATE_FIELD_NUMBER = 102;
      private boolean hasPointDate;
      private double pointDate_ = 0D;
      public boolean hasPointDate() { return hasPointDate; }
      public double getPointDate() { return pointDate_; }
      
      // required double latitude = 103;
      public static final int LATITUDE_FIELD_NUMBER = 103;
      private boolean hasLatitude;
      private double latitude_ = 0D;
      public boolean hasLatitude() { return hasLatitude; }
      public double getLatitude() { return latitude_; }
      
      // required double longitude = 104;
      public static final int LONGITUDE_FIELD_NUMBER = 104;
      private boolean hasLongitude;
      private double longitude_ = 0D;
      public boolean hasLongitude() { return hasLongitude; }
      public double getLongitude() { return longitude_; }
      
      // required double altitude = 105;
      public static final int ALTITUDE_FIELD_NUMBER = 105;
      private boolean hasAltitude;
      private double altitude_ = 0D;
      public boolean hasAltitude() { return hasAltitude; }
      public double getAltitude() { return altitude_; }
      
      // required double speed = 106;
      public static final int SPEED_FIELD_NUMBER = 106;
      private boolean hasSpeed;
      private double speed_ = 0D;
      public boolean hasSpeed() { return hasSpeed; }
      public double getSpeed() { return speed_; }
      
      // required double azimuth = 107;
      public static final int AZIMUTH_FIELD_NUMBER = 107;
      private boolean hasAzimuth;
      private double azimuth_ = 0D;
      public boolean hasAzimuth() { return hasAzimuth; }
      public double getAzimuth() { return azimuth_; }
      
      // optional string stateId = 108;
      public static final int STATEID_FIELD_NUMBER = 108;
      private boolean hasStateId;
      private java.lang.String stateId_ = "";
      public boolean hasStateId() { return hasStateId; }
      public java.lang.String getStateId() { return stateId_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        if (!hasVehicleId) return false;
        if (!hasPointDate) return false;
        if (!hasLatitude) return false;
        if (!hasLongitude) return false;
        if (!hasAltitude) return false;
        if (!hasSpeed) return false;
        if (!hasAzimuth) return false;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasVehicleId()) {
          output.writeString(101, getVehicleId());
        }
        if (hasPointDate()) {
          output.writeDouble(102, getPointDate());
        }
        if (hasLatitude()) {
          output.writeDouble(103, getLatitude());
        }
        if (hasLongitude()) {
          output.writeDouble(104, getLongitude());
        }
        if (hasAltitude()) {
          output.writeDouble(105, getAltitude());
        }
        if (hasSpeed()) {
          output.writeDouble(106, getSpeed());
        }
        if (hasAzimuth()) {
          output.writeDouble(107, getAzimuth());
        }
        if (hasStateId()) {
          output.writeString(108, getStateId());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasVehicleId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(101, getVehicleId());
        }
        if (hasPointDate()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(102, getPointDate());
        }
        if (hasLatitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(103, getLatitude());
        }
        if (hasLongitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(104, getLongitude());
        }
        if (hasAltitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(105, getAltitude());
        }
        if (hasSpeed()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(106, getSpeed());
        }
        if (hasAzimuth()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(107, getAzimuth());
        }
        if (hasStateId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeStringSize(108, getStateId());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row result;
        
        // Construct using ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row other) {
          if (other == ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.getDefaultInstance()) return this;
          if (other.hasVehicleId()) {
            setVehicleId(other.getVehicleId());
          }
          if (other.hasPointDate()) {
            setPointDate(other.getPointDate());
          }
          if (other.hasLatitude()) {
            setLatitude(other.getLatitude());
          }
          if (other.hasLongitude()) {
            setLongitude(other.getLongitude());
          }
          if (other.hasAltitude()) {
            setAltitude(other.getAltitude());
          }
          if (other.hasSpeed()) {
            setSpeed(other.getSpeed());
          }
          if (other.hasAzimuth()) {
            setAzimuth(other.getAzimuth());
          }
          if (other.hasStateId()) {
            setStateId(other.getStateId());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 810: {
                setVehicleId(input.readString());
                break;
              }
              case 817: {
                setPointDate(input.readDouble());
                break;
              }
              case 825: {
                setLatitude(input.readDouble());
                break;
              }
              case 833: {
                setLongitude(input.readDouble());
                break;
              }
              case 841: {
                setAltitude(input.readDouble());
                break;
              }
              case 849: {
                setSpeed(input.readDouble());
                break;
              }
              case 857: {
                setAzimuth(input.readDouble());
                break;
              }
              case 866: {
                setStateId(input.readString());
                break;
              }
            }
          }
        }
        
        
        // required string vehicleId = 101;
        public boolean hasVehicleId() {
          return result.hasVehicleId();
        }
        public java.lang.String getVehicleId() {
          return result.getVehicleId();
        }
        public Builder setVehicleId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasVehicleId = true;
          result.vehicleId_ = value;
          return this;
        }
        public Builder clearVehicleId() {
          result.hasVehicleId = false;
          result.vehicleId_ = getDefaultInstance().getVehicleId();
          return this;
        }
        
        // required double pointDate = 102;
        public boolean hasPointDate() {
          return result.hasPointDate();
        }
        public double getPointDate() {
          return result.getPointDate();
        }
        public Builder setPointDate(double value) {
          result.hasPointDate = true;
          result.pointDate_ = value;
          return this;
        }
        public Builder clearPointDate() {
          result.hasPointDate = false;
          result.pointDate_ = 0D;
          return this;
        }
        
        // required double latitude = 103;
        public boolean hasLatitude() {
          return result.hasLatitude();
        }
        public double getLatitude() {
          return result.getLatitude();
        }
        public Builder setLatitude(double value) {
          result.hasLatitude = true;
          result.latitude_ = value;
          return this;
        }
        public Builder clearLatitude() {
          result.hasLatitude = false;
          result.latitude_ = 0D;
          return this;
        }
        
        // required double longitude = 104;
        public boolean hasLongitude() {
          return result.hasLongitude();
        }
        public double getLongitude() {
          return result.getLongitude();
        }
        public Builder setLongitude(double value) {
          result.hasLongitude = true;
          result.longitude_ = value;
          return this;
        }
        public Builder clearLongitude() {
          result.hasLongitude = false;
          result.longitude_ = 0D;
          return this;
        }
        
        // required double altitude = 105;
        public boolean hasAltitude() {
          return result.hasAltitude();
        }
        public double getAltitude() {
          return result.getAltitude();
        }
        public Builder setAltitude(double value) {
          result.hasAltitude = true;
          result.altitude_ = value;
          return this;
        }
        public Builder clearAltitude() {
          result.hasAltitude = false;
          result.altitude_ = 0D;
          return this;
        }
        
        // required double speed = 106;
        public boolean hasSpeed() {
          return result.hasSpeed();
        }
        public double getSpeed() {
          return result.getSpeed();
        }
        public Builder setSpeed(double value) {
          result.hasSpeed = true;
          result.speed_ = value;
          return this;
        }
        public Builder clearSpeed() {
          result.hasSpeed = false;
          result.speed_ = 0D;
          return this;
        }
        
        // required double azimuth = 107;
        public boolean hasAzimuth() {
          return result.hasAzimuth();
        }
        public double getAzimuth() {
          return result.getAzimuth();
        }
        public Builder setAzimuth(double value) {
          result.hasAzimuth = true;
          result.azimuth_ = value;
          return this;
        }
        public Builder clearAzimuth() {
          result.hasAzimuth = false;
          result.azimuth_ = 0D;
          return this;
        }
        
        // optional string stateId = 108;
        public boolean hasStateId() {
          return result.hasStateId();
        }
        public java.lang.String getStateId() {
          return result.getStateId();
        }
        public Builder setStateId(java.lang.String value) {
          if (value == null) {
    throw new NullPointerException();
  }
  result.hasStateId = true;
          result.stateId_ = value;
          return this;
        }
        public Builder clearStateId() {
          result.hasStateId = false;
          result.stateId_ = getDefaultInstance().getStateId();
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.Row)
      }
      
      static {
        defaultInstance = new Row(true);
        ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.Row)
    }
    
    // required int32 messageType = 2;
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 0;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // optional string instanceId = 4;
    public static final int INSTANCEID_FIELD_NUMBER = 4;
    private boolean hasInstanceId;
    private java.lang.String instanceId_ = "";
    public boolean hasInstanceId() { return hasInstanceId; }
    public java.lang.String getInstanceId() { return instanceId_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.Row rows = 201;
    public static final int ROWS_FIELD_NUMBER = 201;
    private java.util.List<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row> rows_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row> getRowsList() {
      return rows_;
    }
    public int getRowsCount() { return rows_.size(); }
    public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row getRows(int index) {
      return rows_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.State blockState = 300;
    public static final int BLOCKSTATE_FIELD_NUMBER = 300;
    private boolean hasBlockState;
    private ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State blockState_;
    public boolean hasBlockState() { return hasBlockState; }
    public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State getBlockState() { return blockState_; }
    
    // optional int32 blockNumber = 301;
    public static final int BLOCKNUMBER_FIELD_NUMBER = 301;
    private boolean hasBlockNumber;
    private int blockNumber_ = 0;
    public boolean hasBlockNumber() { return hasBlockNumber; }
    public int getBlockNumber() { return blockNumber_; }
    
    private void initFields() {
      blockState_ = ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State.NORMAL;
    }
    public final boolean isInitialized() {
      if (!hasMessageType) return false;
      for (ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row element : getRowsList()) {
        if (!element.isInitialized()) return false;
      }
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasInstanceId()) {
        output.writeString(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row element : getRowsList()) {
        output.writeMessage(201, element);
      }
      if (hasBlockState()) {
        output.writeEnum(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        output.writeInt32(301, getBlockNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasInstanceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeStringSize(4, getInstanceId());
      }
      for (ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row element : getRowsList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(201, element);
      }
      if (hasBlockState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(300, getBlockState().getNumber());
      }
      if (hasBlockNumber()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(301, getBlockNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse result;
      
      // Construct using ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.rows_ != java.util.Collections.EMPTY_LIST) {
          result.rows_ =
            java.util.Collections.unmodifiableList(result.rows_);
        }
        ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse other) {
        if (other == ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.getDefaultInstance()) return this;
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasInstanceId()) {
          setInstanceId(other.getInstanceId());
        }
        if (!other.rows_.isEmpty()) {
          if (result.rows_.isEmpty()) {
            result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row>();
          }
          result.rows_.addAll(other.rows_);
        }
        if (other.hasBlockState()) {
          setBlockState(other.getBlockState());
        }
        if (other.hasBlockNumber()) {
          setBlockNumber(other.getBlockNumber());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 34: {
              setInstanceId(input.readString());
              break;
            }
            case 1610: {
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.Builder subBuilder = ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addRows(subBuilder.buildPartial());
              break;
            }
            case 2400: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State value = ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(300, rawValue);
              } else {
                setBlockState(value);
              }
              break;
            }
            case 2408: {
              setBlockNumber(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 messageType = 2;
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 0;
        return this;
      }
      
      // optional string instanceId = 4;
      public boolean hasInstanceId() {
        return result.hasInstanceId();
      }
      public java.lang.String getInstanceId() {
        return result.getInstanceId();
      }
      public Builder setInstanceId(java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  result.hasInstanceId = true;
        result.instanceId_ = value;
        return this;
      }
      public Builder clearInstanceId() {
        result.hasInstanceId = false;
        result.instanceId_ = getDefaultInstance().getInstanceId();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.Row rows = 201;
      public java.util.List<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row> getRowsList() {
        return java.util.Collections.unmodifiableList(result.rows_);
      }
      public int getRowsCount() {
        return result.getRowsCount();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row getRows(int index) {
        return result.getRows(index);
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.rows_.set(index, value);
        return this;
      }
      public Builder setRows(int index, ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.Builder builderForValue) {
        result.rows_.set(index, builderForValue.build());
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row>();
        }
        result.rows_.add(value);
        return this;
      }
      public Builder addRows(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.Builder builderForValue) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row>();
        }
        result.rows_.add(builderForValue.build());
        return this;
      }
      public Builder addAllRows(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row> values) {
        if (result.rows_.isEmpty()) {
          result.rows_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row>();
        }
        super.addAll(values, result.rows_);
        return this;
      }
      public Builder clearRows() {
        result.rows_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse.State blockState = 300;
      public boolean hasBlockState() {
        return result.hasBlockState();
      }
      public ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State getBlockState() {
        return result.getBlockState();
      }
      public Builder setBlockState(ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasBlockState = true;
        result.blockState_ = value;
        return this;
      }
      public Builder clearBlockState() {
        result.hasBlockState = false;
        result.blockState_ = ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.State.NORMAL;
        return this;
      }
      
      // optional int32 blockNumber = 301;
      public boolean hasBlockNumber() {
        return result.hasBlockNumber();
      }
      public int getBlockNumber() {
        return result.getBlockNumber();
      }
      public Builder setBlockNumber(int value) {
        result.hasBlockNumber = true;
        result.blockNumber_ = value;
        return this;
      }
      public Builder clearBlockNumber() {
        result.hasBlockNumber = false;
        result.blockNumber_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse)
    }
    
    static {
      defaultInstance = new GeographyParametersResponse(true);
      ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponse)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n!GeographyParametersResponse.proto\022,ru." +
      "omnicomm.pegasus.messaging.data.response" +
      "s\"\344\003\n\033GeographyParametersResponse\022\023\n\013mes" +
      "sageType\030\002 \002(\005\022\022\n\ninstanceId\030\004 \001(\t\022\\\n\004ro" +
      "ws\030\311\001 \003(\0132M.ru.omnicomm.pegasus.messagin" +
      "g.data.responses.GeographyParametersResp" +
      "onse.Row\022d\n\nblockState\030\254\002 \001(\0162O.ru.omnic" +
      "omm.pegasus.messaging.data.responses.Geo" +
      "graphyParametersResponse.State\022\024\n\013blockN" +
      "umber\030\255\002 \001(\005\032\223\001\n\003Row\022\021\n\tvehicleId\030e \002(\t\022",
      "\021\n\tpointDate\030f \002(\001\022\020\n\010latitude\030g \002(\001\022\021\n\t" +
      "longitude\030h \002(\001\022\020\n\010altitude\030i \002(\001\022\r\n\005spe" +
      "ed\030j \002(\001\022\017\n\007azimuth\030k \002(\001\022\017\n\007stateId\030l \001" +
      "(\t\",\n\005State\022\n\n\006NORMAL\020\000\022\010\n\004LAST\020\001\022\r\n\tDEF" +
      "ECTIVE\020\002BQ\n,ru.omnicomm.pegasus.messagin" +
      "g.data.responsesB!GeographyParametersRes" +
      "ponseParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_descriptor,
              new java.lang.String[] { "MessageType", "InstanceId", "Rows", "BlockState", "BlockNumber", },
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.class,
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_data_responses_GeographyParametersResponse_Row_descriptor,
              new java.lang.String[] { "VehicleId", "PointDate", "Latitude", "Longitude", "Altitude", "Speed", "Azimuth", "StateId", },
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.class,
              ru.omnicomm.pegasus.messaging.data.responses.GeographyParametersResponseParser.GeographyParametersResponse.Row.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
